/* 
 * Proview   $Id: op_resources.h,v 1.2 2005-09-01 14:57:49 claes Exp $
 * Copyright (C) 2005 SSAB Oxelsund AB.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with the program, if not, write to the Free Software 
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef op_resources_h
#define op_resources_h

/* op_resources.h -- <short description>
   Defines application resources and default values
   for the operator environment.  */

#define PwrCaAlarmBackground		"PwraAlarmBackground"
#define PwrNaAlarmBackground		"pwraAlarmBackground"
#define PwrCaAlarmForeground		"PwraAlarmForeground"
#define PwrNaAlarmForeground		"pwraAlarmForeground"

#define PwrCbAlarmBackground		"PwrbAlarmBackground"
#define PwrNbAlarmBackground		"pwrbAlarmBackground"
#define PwrCbAlarmForeground		"PwrbAlarmForeground"
#define PwrNbAlarmForeground		"pwrbAlarmForeground"

#define PwrCcAlarmBackground		"PwrcAlarmBackground"
#define PwrNcAlarmBackground		"pwrcAlarmBackground"
#define PwrCcAlarmForeground		"PwrcAlarmForeground"
#define PwrNcAlarmForeground		"pwrcAlarmForeground"

#define PwrCdAlarmBackground		"PwrdAlarmBackground"
#define PwrNdAlarmBackground		"pwrdAlarmBackground"
#define PwrCdAlarmForeground		"PwrdAlarmForeground"
#define PwrNdAlarmForeground		"pwrdAlarmForeground"

#define PwrCmsgBackground		"PwrmsgBackground"
#define PwrNmsgBackground		"pwrmsgBackground"
#define PwrCmsgForeground		"PwrmsgForeground"
#define PwrNmsgForeground		"pwrmsgForeground"



#define PwrCplantHierTop		"PwrplantHierTop"
#define PwrNplantHierTop		"pwrplantHierTop"
#define PwrCnodeHierTop			"PwrnodeHierTop"
#define PwrNnodeHierTop                 "pwrnodeHierTop"
#define	PwrCautoUpdate			"PwrautoUpdate"
#define	PwrNautoUpdate			"pwrautoUpdate"
#define PwrCupdateInterval		"PwrupdateInterval"
#define PwrNupdateInterval		"pwrupdateInterval"
#define PwrCattributeUpdateInterval	"PwrattributeUpdateInterval"
#define PwrNattributeUpdateInterval	"pwrattributeUpdateInterval"


#define PwraAlarmBackgroundDefault	"red"
#define PwraAlarmForegroundDefault	"white"
#define PwrbAlarmBackgroundDefault	"yellow"
#define PwrbAlarmForegroundDefault	"black"
#define PwrcAlarmBackgroundDefault	"cyan"
#define PwrcAlarmForegroundDefault	"black"
#define PwrdAlarmBackgroundDefault	"orchid"
#define PwrdAlarmForegroundDefault	"black"
#define PwrmsgBackgroundDefault		"green"
#define PwrmsgForegroundDefault		"black"


#endif
