/* 
 * Proview   $Id: rt_futex.h,v 1.2 2005-09-01 14:57:57 claes Exp $
 * Copyright (C) 2005 SSAB Oxelsund AB.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with the program, if not, write to the Free Software 
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef rt_futex_h
#define rt_futex_h

#ifdef __cplusplus
extern "C" { 
#endif
    int futex_wait(int *futex, int val);
    
    int futex_timed_wait(int *futex, int val, const struct timespec * timespec);
    
    int futex_wake(int *futex,int nr);

#ifdef __cplusplus
} 
#endif

#endif
